> For the complete documentation index, see [llms.txt](https://docs.coda.co/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.coda.co/codapay/archived-tokenization-api-2.0/payment-method-details.md).

# Payment Method Details

This section helps to specify what information is needed per payment method during the [Create Payment Method](/codapay/archived-tokenization-api-2.0/integration-guide/payment-method.md#create-payment-method) step of the flow.

## <mark style="color:purple;">GoPay</mark>

```
{
  "shopper_id": "{shopper.id}",
  "type": "gopay",
  "gopay": {
    "country_code": "ID",
    "msisdn": "+6281231684642"
  }
}
```

### <mark style="color:purple;">Request Parameters</mark>

<table data-full-width="false"><thead><tr><th width="177">Parameter Name</th><th width="78">Type</th><th width="103">Required</th><th width="210">Description</th><th>Validation</th></tr></thead><tbody><tr><td>shopper_id</td><td>String</td><td>Yes</td><td>Shopper ID will be generated by Coda</td><td>Shopper ID must have a length between 20 and 32 and follow the pattern [A-Za-z]+_[A-Za-z0-9]+</td></tr><tr><td>type</td><td>String</td><td>Yes</td><td>Type of payment method</td><td>Type must have a length between 3 and 64 and follow the pattern [a-zA-Z0-9_]+</td></tr><tr><td>gopay.country_code</td><td>String</td><td>Yes</td><td>Country associated with payment method using ISO 3166 ALPHA-2 country codes</td><td>Country code length must be 2 and follow the pattern (\w{2})</td></tr><tr><td>gopay.msisdn</td><td>String</td><td>Yes</td><td>Mobile number associated with payment method</td><td>Msisdn length must be between 12 and 16 and must follow the pattern +[0-9]+</td></tr></tbody></table>

### <mark style="color:purple;">Payment Method GoPay Object</mark>

<table><thead><tr><th width="207">Parameter name</th><th width="86.33333333333331">Type</th><th>Description</th></tr></thead><tbody><tr><td>id</td><td>String</td><td>Payment Method ID generated by Coda</td></tr><tr><td>shopper_id</td><td>String</td><td>Shopper ID generated by Coda</td></tr><tr><td>type</td><td>String</td><td>Type of Payment Method</td></tr><tr><td>gopay.id</td><td>String</td><td>Payment Method Go Pay ID generated by Coda</td></tr><tr><td>gopay.country_code</td><td>String</td><td>The country code associated with the specified payment method using GoPay</td></tr><tr><td>gopay.msisdn</td><td>String</td><td>The phone number associated with the specified payment method using GoPay</td></tr></tbody></table>

## <mark style="color:purple;">Mada - Card Payment Method</mark>

```
{
  "shopper_id": "{shopper.id}",
  "type": "card",
  "card": {
    "country_code": "SA"
  }
}

```

### <mark style="color:purple;">Request Parameters</mark>

<table data-full-width="false"><thead><tr><th width="176">Parameter Name</th><th width="78">Type</th><th width="100">Required</th><th width="205">Description</th><th>Validation</th></tr></thead><tbody><tr><td>shopper_id</td><td>String</td><td>Yes</td><td>Shopper ID will be generated by Coda</td><td>Shopper ID must have a length between 20 and 32 and follow the pattern [A-Za-z]+_[A-Za-z0-9]+</td></tr><tr><td>type</td><td>String</td><td>Yes</td><td>Type of payment method</td><td>Type must have a length between 3 and 64 and follow the pattern [a-zA-Z0-9_]+</td></tr><tr><td>card.country_code</td><td>String</td><td>Yes</td><td>Country associated with payment method using ISO 3166 ALPHA-2 country codes</td><td>Country code length must be 2 and follow the pattern (\w{2})</td></tr></tbody></table>

### <mark style="color:purple;">Payment Method Card Object</mark>

<table><thead><tr><th width="194">Parameter Name</th><th width="126.33333333333331">Type</th><th>Description</th></tr></thead><tbody><tr><td>id</td><td>String</td><td>Payment Method ID generated by Coda</td></tr><tr><td>shopper_id</td><td>String</td><td>Shopper ID generated by Coda</td></tr><tr><td>type</td><td>String</td><td>Type of Payment Method</td></tr><tr><td>card.id</td><td>String</td><td>Payment Method Card ID generated by Coda</td></tr><tr><td>card.country_code</td><td>String</td><td>The country code associated with the payment method using a card</td></tr><tr><td>card.last_four</td><td>String</td><td>The Last 4 digits of Card Number</td></tr></tbody></table>

## <mark style="color:purple;">DANA Wallet</mark>

```json
{
  "shopper_id": "{{shopper.id}}",
  "type": "dana",
  "dana": {
    "country_code": "ID"
  }
}
```

### <mark style="color:purple;">Request Parameters</mark>

<table data-full-width="false"><thead><tr><th>Parameter Name</th><th width="82">Type</th><th width="107">Required</th><th width="252">Description</th><th>Validation</th></tr></thead><tbody><tr><td>shopper_id</td><td>String</td><td>Yes</td><td>Shopper ID will be generated by Coda</td><td>Shopper ID must have a length between 20 and 32 and follow the pattern [A-Za-z]+_[A-Za-z0-9]+</td></tr><tr><td>type</td><td>String</td><td>Yes</td><td>Type of payment method</td><td>Type must have a length between 3 and 64 and follow the pattern [a-zA-Z0-9_]+</td></tr><tr><td>dana.country_code</td><td>String</td><td>Yes</td><td>Country associated with payment method using ISO 3166 ALPHA-2 country codes</td><td>Country code length must be 2 and follow the pattern (\w{2})</td></tr></tbody></table>

### <mark style="color:purple;">**Payment Method DANA Object**</mark>

<table><thead><tr><th width="199">Parameter name</th><th width="125">Type</th><th>Description</th></tr></thead><tbody><tr><td>id</td><td>String</td><td>Payment Method ID generated by Coda</td></tr><tr><td>shopper_id</td><td>String</td><td>Shopper ID generated by Coda</td></tr><tr><td>type</td><td>String</td><td>Type of Payment Method</td></tr><tr><td>dana.id</td><td>String</td><td>Payment Method DANA ID generated by Coda</td></tr><tr><td>dana.country_code</td><td>String</td><td>The country code associated with the specified payment method using DANA Wallet</td></tr></tbody></table>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.coda.co/codapay/archived-tokenization-api-2.0/payment-method-details.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
